Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/Helpers/Current.cs
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/Helpers/Current.cs	(revision 5254)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/Helpers/Current.cs	(revision 5254)
@@ -0,0 +1,377 @@
+﻿//*********************************************************
+//
+// Copyright (c) Microsoft. All rights reserved.
+// This code is licensed under the MIT License (MIT).
+// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
+// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
+// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
+// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
+//
+//*********************************************************
+using System;
+using System.Threading.Tasks;
+using System.Diagnostics;
+using VoipTasks.BackgroundOperations;
+using Windows.ApplicationModel.AppService;
+using Windows.ApplicationModel.Background;
+using Windows.ApplicationModel.Calls;
+using Windows.Foundation.Collections;
+using VoipBackEnd;
+
+namespace VoipTasks.Helpers
+{
+    static class Current
+    {
+        public static String RtcCallTaskName
+        {
+            get { return _rtcCallTaskName; }
+        }
+
+        public static AppServiceRequest AppRequest
+        {
+            set
+            {
+                lock (_lock)
+                {
+                    _appRequest = value;
+                }
+            }
+            get
+            {
+                lock (_lock)
+                {
+                    return _appRequest;
+                }
+            }
+        }
+
+        public static AppServiceDeferral AppRequestDeferal
+        {
+            set
+            {
+                lock (_lock)
+                {
+                    _appDeferral = value;
+                }
+            }
+            get
+            {
+                lock (_lock)
+                {
+                    return _appDeferral;
+                }
+            }
+        }
+
+        public static BackgroundTaskDeferral RTCTaskDeferral
+        {
+            set
+            {
+                lock (_lock)
+                {
+                    _rtcTaskDeferral = value;
+                }
+            }
+            get
+            {
+                lock (_lock)
+                {
+                    return _rtcTaskDeferral;
+                }
+            }
+        }
+
+        public static VoipPhoneCall VoipCall
+        {
+            set
+            {
+                lock (_lock)
+                {
+                    _voipCall = value;
+                }
+            }
+            get
+            {
+                lock (_lock)
+                {
+                    return _voipCall;
+                }
+            }
+        }
+
+        public static BackgroundRequest Request
+        {
+            set
+            {
+                lock (_lock)
+                {
+                    _request = value;
+                }
+            }
+            get
+            {
+                lock (_lock)
+                {
+                    return _request;
+                }
+            }
+        }
+        
+        public static AppServiceConnection AppConnection
+        {
+            set
+            {
+                lock (_lock)
+                {
+                    _connection = value;
+                }
+            }
+            get
+            {
+                lock (_lock)
+                {
+                    return _connection;
+                }
+            }
+        }
+
+        public static MyAppRT MyApp
+        {
+            get
+            {
+                lock (_lock)
+                {
+                    return _myApp;
+                }
+            }
+        }
+
+        public static async void SendResponse(ValueSet response)
+        {
+            AppServiceRequest request = AppRequest;
+            AppServiceDeferral deferal = AppRequestDeferal;
+
+            try
+            {
+                if (request != null)
+                {
+                    await request.SendResponseAsync(response);
+                }
+            }
+            finally
+            {
+                if (deferal != null)
+                {
+                    deferal.Complete();
+                    deferal = null;
+                }
+
+                AppRequest = null;
+            }
+        }
+
+        public static async Task<ValueSet> SendMessageAsync(ValueSet message)
+        {
+            ValueSet returnValue = null;
+
+            if (_connection != null)
+            {
+                AppServiceResponse response = await _connection.SendMessageAsync(message);
+
+                if (response.Status == AppServiceResponseStatus.Success)
+                {
+                    if (response.Message.Keys.Contains(BackgroundOperation.Result))
+                    {
+                        returnValue = response.Message;
+                    }
+                }
+            }
+
+            return returnValue;
+        }
+
+        public static async void EndCallAsync()
+        {
+            AppServiceRequest request = AppRequest;
+            AppServiceDeferral deferal = AppRequestDeferal;
+
+            try
+            {                
+                EndCall();
+                
+                if (request != null)
+                {
+                    ValueSet response = new ValueSet();
+                    response[BackgroundOperation.Result] = (int)OperationResult.Succeeded;
+                    await request.SendResponseAsync(response);
+                }
+
+                if (deferal != null)
+                {
+                    deferal.Complete();
+                }
+            }
+            finally
+            {
+                AppRequest = null;
+                AppRequestDeferal = null;
+            }
+        }
+
+
+        public static void EndCall()
+        {
+            VoipPhoneCall call = VoipCall;
+            BackgroundTaskDeferral deferral = RTCTaskDeferral;
+
+            if (_voipCall == null) {
+                return;
+            }
+
+            try
+            {
+                _myApp.hangupCall();
+            }
+            catch (Exception e)
+            {
+                _myApp.writeLog(2, e.Message);
+            }            
+
+            try
+            {                
+                if (call != null)
+                {
+                    call.NotifyCallEnded();
+                }
+            }
+            catch
+            {
+
+            }
+
+            try
+            {
+                if (deferral != null)
+                {
+                    deferral.Complete();
+                }
+
+            }
+            catch
+            {
+
+            }
+            finally
+            {
+                VoipCall = null;
+                RTCTaskDeferral = null;
+            }
+        }
+
+        public static async Task<VoipPhoneCallResourceReservationStatus> RequestNewCallAsync(string dstURI)
+        {
+            VccCallHelper vccCallHelper;
+            VoipPhoneCallResourceReservationStatus status = VoipPhoneCallResourceReservationStatus.ResourcesNotAvailable;
+
+            lock (_lock)
+            {
+                vccCallHelper = _vccCallHelper;
+            }
+
+            if (vccCallHelper != null)
+            {
+                status = await vccCallHelper.RequestNewCallAsync(dstURI);
+            }
+
+            return status;
+        }
+
+        public static void RequestNewIncomingCall(string context, string contactName, string serviceName)
+        {
+            VccCallHelper vccCallHelper;
+
+
+            lock (_lock)
+            {
+                vccCallHelper = _vccCallHelper;
+            }
+
+            if (vccCallHelper != null)
+            {
+                vccCallHelper.NewIncomingCall(context, contactName, serviceName);
+            }
+        }
+
+        public static void StartService()
+        {
+            if (_started)
+                return;
+
+            _myApp.init(_epHelper, _epHelper);
+
+            _started = true;
+        }
+
+
+        public static void StopService()
+        {
+            if (!_started)
+                return;
+
+            _myApp.deInit();
+
+            _started = false;
+        }
+
+        public static void ModifyAccount(String id, String registrar,
+                                         String proxy, String username, 
+                                         String password)
+        {
+            try
+            {
+                MyAppRT.Instance.modifyAccount(id, registrar, proxy, username, password);
+            }
+            catch (Exception e)
+            {
+                MyAppRT.Instance.writeLog(2, e.Message);
+            }            
+        }
+
+        async public static void GetAccountInfo()
+        {
+            if (!_started)
+                return;
+
+            AccountInfo accInfo = MyAppRT.Instance.getAccountInfo();
+
+            ValueSet message = new ValueSet();
+
+            message[UpdateAccountInfoArguments.id.ToString()] = accInfo.id;
+            message[UpdateAccountInfoArguments.registrar.ToString()] = accInfo.registrar;
+            message[UpdateAccountInfoArguments.proxy.ToString()] = accInfo.proxy;
+            message[UpdateAccountInfoArguments.username.ToString()] = accInfo.username;
+            message[UpdateAccountInfoArguments.password.ToString()] = accInfo.password;
+
+            message[ForegroundOperation.NewForegroundRequest] = (int)ForegroundReguest.UpdateAcccountInfo;
+
+            ValueSet response = await Current.SendMessageAsync(message);
+
+        }
+
+        private const String _rtcCallTaskName = "VoipTasks.CallRtcTask";
+        private static BackgroundRequest _request = BackgroundRequest.InValid;
+        private static Object _lock = new Object();
+        private static AppServiceRequest _appRequest = null;
+        private static AppServiceDeferral _appDeferral = null;
+        private static VoipPhoneCall _voipCall = null;
+        private static VccCallHelper _vccCallHelper = new VccCallHelper();
+        private static BackgroundTaskDeferral _rtcTaskDeferral = null;
+
+        /* Pjsua data */
+        private static MyAppRT _myApp = MyAppRT.Instance;
+        private static bool _started = false;
+
+        private static EndpointHelper _epHelper = new EndpointHelper();
+        private static AppServiceConnection _connection = null;
+    }
+}
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/Helpers/EndpointHelper.cs
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/Helpers/EndpointHelper.cs	(revision 5254)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/Helpers/EndpointHelper.cs	(revision 5254)
@@ -0,0 +1,94 @@
+﻿/* $Id*/
+/*
+* Copyright (C) 2016 Teluu Inc. (http://www.teluu.com)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+*
+* You should have received a copy of the GNU General Public License
+* along with this program; if not, write to the Free Software
+* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+*/
+
+using System;
+using System.Diagnostics;
+using System.Threading.Tasks;
+using VoipTasks.BackgroundOperations;
+using Windows.ApplicationModel.Calls;
+using Windows.Foundation.Collections;
+using VoipBackEnd;
+
+namespace VoipTasks.Helpers
+{
+    class EndpointHelper : IntAccount, IntCall
+    {        
+        private async void sendCallState(String state)
+        {            
+            ValueSet message = new ValueSet();
+
+            message[UpdateCallStateArguments.CallState.ToString()] = state;
+            message[ForegroundOperation.NewForegroundRequest] = (int)ForegroundReguest.UpdateCallState;
+
+            ValueSet response = await Current.SendMessageAsync(message);
+        }
+
+        private async void sendRegState(String state)
+        {
+            ValueSet message = new ValueSet();
+
+            message[UpdateRegStateArguments.RegState.ToString()] = state;
+            message[ForegroundOperation.NewForegroundRequest] = (int)ForegroundReguest.UpdateRegState;
+
+            ValueSet response = await Current.SendMessageAsync(message);
+        }
+
+        /* Implement IntAccount. */
+        public void onIncomingCall(CallInfoRT info)
+        {
+            if (Current.VoipCall != null)
+            {
+                /* Only one active call */
+                return;
+            }
+
+            Current.RequestNewIncomingCall(info.remoteContact,
+                                           info.remoteUri,
+                                           "Pjsua");
+        }
+
+        public void onRegState(OnRegStateParamRT prm)
+        {
+            sendRegState(prm.reason);
+        }
+
+        /* Implement IntCall. */
+        public void onCallState(CallInfoRT info)
+        {
+            switch (info.state) {
+                case INV_STATE.PJSIP_INV_STATE_CALLING:
+                    sendCallState("Calling");
+                    break;
+                case INV_STATE.PJSIP_INV_STATE_INCOMING:
+                    sendCallState("Incoming");
+                    break;
+                case INV_STATE.PJSIP_INV_STATE_CONNECTING:
+                    sendCallState("Connecting");
+                    break;
+                case INV_STATE.PJSIP_INV_STATE_CONFIRMED:
+                    sendCallState("Connected");
+                    break;
+                case INV_STATE.PJSIP_INV_STATE_DISCONNECTED:                    
+                    sendCallState("Disconnected");
+                    Current.EndCall();
+                    break;
+            }
+        }
+    }
+}
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/Helpers/VccCallHelper.cs
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/Helpers/VccCallHelper.cs	(revision 5254)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/Helpers/VccCallHelper.cs	(revision 5254)
@@ -0,0 +1,164 @@
+﻿//*********************************************************
+//
+// Copyright (c) Microsoft. All rights reserved.
+// This code is licensed under the MIT License (MIT).
+// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
+// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
+// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
+// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
+//
+//*********************************************************
+using System;
+using System.Diagnostics;
+using System.Threading.Tasks;
+using VoipTasks.BackgroundOperations;
+using Windows.ApplicationModel.Calls;
+using Windows.Foundation.Collections;
+using Windows.Foundation.Metadata;
+using VoipBackEnd;
+
+namespace VoipTasks.Helpers
+{
+    class VccCallHelper
+    {
+        private int RTcTaskAlreadyRuningErrorCode = -2147024713;
+        public async Task<VoipPhoneCallResourceReservationStatus> RequestNewCallAsync(string dstURI)
+        {
+            VoipPhoneCallResourceReservationStatus status = VoipPhoneCallResourceReservationStatus.ResourcesNotAvailable;
+            
+            status = await LaunchRTCTaskAsync();
+            if (status == VoipPhoneCallResourceReservationStatus.Success)
+            {
+                NewOutgoingCall(dstURI);
+            }
+
+            Current.Request = BackgroundRequest.InValid;
+
+            return status;
+        }
+
+        private async Task<VoipPhoneCallResourceReservationStatus> LaunchRTCTaskAsync()
+        {
+            // End current call before starting another call, there should be only one RTC task active at a time.
+            // Duplicate calls to launch RTC task will result in HR ERROR_ALREADY_EXSIST
+            // <TODO> For multiple calls against single rtc task add logic to verify that the rtc is not completed, 
+            // and then Skip launching new rtc task
+            Current.EndCall();
+
+            VoipCallCoordinator vCC = VoipCallCoordinator.GetDefault();
+            VoipPhoneCallResourceReservationStatus status = VoipPhoneCallResourceReservationStatus.ResourcesNotAvailable;
+
+            try
+            {
+                status = await vCC.ReserveCallResourcesAsync(Current.RtcCallTaskName);
+            }
+            catch (Exception ex)
+            {
+                if (ex.HResult == RTcTaskAlreadyRuningErrorCode )
+                {
+                    Debug.WriteLine("RTC Task Already running");
+                }
+            }
+
+            return status;
+        }
+
+        internal void NewOutgoingCall(string dstURI)
+        {
+            bool status = false;
+            try
+            {
+                VoipCallCoordinator vCC = VoipCallCoordinator.GetDefault();
+                VoipPhoneCall call = vCC.RequestNewOutgoingCall( "Pjsua Test Call ", dstURI, "", VoipPhoneCallMedia.Audio);
+                if (call != null)
+                {
+                    call.EndRequested += Call_EndRequested;
+                    call.RejectRequested += Call_RejectRequested;
+
+                    call.NotifyCallActive();
+
+                    Current.VoipCall = call;
+
+                    MyAppRT.Instance.makeCall(dstURI);
+
+                    status = true;
+                }
+            }
+            catch (Exception e)
+            {
+                Debug.WriteLine(e.ToString());
+            }
+
+            ValueSet response = new ValueSet();
+            response[BackgroundOperation.Result] = status ? (int)OperationResult.Succeeded : (int)OperationResult.Failed;
+
+            Current.SendResponse(response);
+        }
+
+        internal void NewIncomingCall(string context, string contactName, string serviceName)
+        {
+            try
+            {
+                VoipCallCoordinator vCC = VoipCallCoordinator.GetDefault();
+                VoipPhoneCall call = vCC.RequestNewIncomingCall(
+                                                                "Hello",
+                                                                contactName,
+                                                                context,
+                                                                new Uri("file://c:/data/test/bin/FakeVoipAppLight.png"),
+                                                                serviceName,
+                                                                new Uri("file://c:/data/test/bin/FakeVoipAppLight.png"),
+                                                                "",
+                                                               new Uri("file://c:/data/test/bin/FakeVoipAppRingtone.wma"),
+                                                                VoipPhoneCallMedia.Audio,
+                                                                new TimeSpan(0, 1, 20));
+                if (call != null)
+                {
+                    call.AnswerRequested += Call_AnswerRequested;
+                    call.EndRequested += Call_EndRequested;
+                    call.RejectRequested += Call_RejectRequested;
+
+                    Current.VoipCall = call;
+                }
+            }
+            catch (Exception e)
+            {
+                Debug.WriteLine(e.ToString());
+            }
+        }
+
+        private void Call_RejectRequested(VoipPhoneCall sender, CallRejectEventArgs args)
+        {
+            Current.EndCall();
+        }
+
+        private void Call_EndRequested(VoipPhoneCall sender, CallStateChangeEventArgs args)
+        {
+            Current.EndCall();
+        }
+
+        private void Call_AnswerRequested(VoipPhoneCall sender, CallAnswerEventArgs args)
+        {            
+            CallOpParamRT param = new CallOpParamRT();
+            param.statusCode = 200;
+            param.reason = "OK";
+
+            try
+            {
+                Current.MyApp.answerCall(param);
+            }
+            catch (Exception ex)
+            {                
+                Current.MyApp.writeLog(2, ex.Message);
+            }
+            Current.VoipCall = sender;
+            try
+            {
+                Current.VoipCall.NotifyCallActive();
+            }
+            catch (Exception ex)
+            {                
+                Current.MyApp.writeLog(2, ex.Message);
+            }            
+        }
+    }
+}
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/Properties/AssemblyInfo.cs
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/Properties/AssemblyInfo.cs	(revision 5254)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/Properties/AssemblyInfo.cs	(revision 5254)
@@ -0,0 +1,29 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("VoIPTasks")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("Microsoft Corporation")]
+[assembly: AssemblyProduct("VoIPTasks")]
+[assembly: AssemblyCopyright("Copyright ©  2015")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
+[assembly: ComVisible(false)]
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/VoipTasks.csproj
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/VoipTasks.csproj	(revision 5254)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/VoipTasks.csproj	(revision 5254)
@@ -0,0 +1,147 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{9FDF5E33-D15D-409F-876E-4E77727936B9}</ProjectGuid>
+    <OutputType>winmdobj</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>VoipTasks</RootNamespace>
+    <AssemblyName>VoipTasks</AssemblyName>
+    <DefaultLanguage>en-US</DefaultLanguage>
+    <TargetPlatformIdentifier>UAP</TargetPlatformIdentifier>
+    <TargetPlatformVersion>10.0.10586.0</TargetPlatformVersion>
+    <TargetPlatformMinVersion>10.0.10240.0</TargetPlatformMinVersion>
+    <MinimumVisualStudioVersion>14</MinimumVisualStudioVersion>
+    <FileAlignment>512</FileAlignment>
+    <ProjectTypeGuids>{A5A43C5B-DE2A-4C0C-9213-0A381AF9435A};{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}</ProjectTypeGuids>
+    <AllowCrossPlatformRetargeting>false</AllowCrossPlatformRetargeting>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <PlatformTarget>AnyCPU</PlatformTarget>
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE;NETFX_CORE;WINDOWS_UAP</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <PlatformTarget>AnyCPU</PlatformTarget>
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE;NETFX_CORE;WINDOWS_UAP</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|ARM'">
+    <PlatformTarget>ARM</PlatformTarget>
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\ARM\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE;NETFX_CORE;WINDOWS_UAP</DefineConstants>
+    <NoWarn>;2008</NoWarn>
+    <DebugType>full</DebugType>
+    <PlatformTarget>ARM</PlatformTarget>
+    <UseVSHostingProcess>false</UseVSHostingProcess>
+    <ErrorReport>prompt</ErrorReport>
+    <Prefer32Bit>true</Prefer32Bit>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|ARM'">
+    <PlatformTarget>ARM</PlatformTarget>
+    <OutputPath>bin\ARM\Release\</OutputPath>
+    <DefineConstants>TRACE;NETFX_CORE;WINDOWS_UAP</DefineConstants>
+    <Optimize>true</Optimize>
+    <NoWarn>;2008</NoWarn>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>ARM</PlatformTarget>
+    <UseVSHostingProcess>false</UseVSHostingProcess>
+    <ErrorReport>prompt</ErrorReport>
+    <Prefer32Bit>true</Prefer32Bit>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
+    <PlatformTarget>x64</PlatformTarget>
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x64\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE;NETFX_CORE;WINDOWS_UAP</DefineConstants>
+    <NoWarn>;2008</NoWarn>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <UseVSHostingProcess>false</UseVSHostingProcess>
+    <ErrorReport>prompt</ErrorReport>
+    <Prefer32Bit>true</Prefer32Bit>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
+    <PlatformTarget>x64</PlatformTarget>
+    <OutputPath>bin\x64\Release\</OutputPath>
+    <DefineConstants>TRACE;NETFX_CORE;WINDOWS_UAP</DefineConstants>
+    <Optimize>true</Optimize>
+    <NoWarn>;2008</NoWarn>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <UseVSHostingProcess>false</UseVSHostingProcess>
+    <ErrorReport>prompt</ErrorReport>
+    <Prefer32Bit>true</Prefer32Bit>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x86'">
+    <PlatformTarget>x86</PlatformTarget>
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE;NETFX_CORE;WINDOWS_UAP</DefineConstants>
+    <NoWarn>;2008</NoWarn>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <UseVSHostingProcess>false</UseVSHostingProcess>
+    <ErrorReport>prompt</ErrorReport>
+    <Prefer32Bit>true</Prefer32Bit>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x86'">
+    <PlatformTarget>x86</PlatformTarget>
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE;NETFX_CORE;WINDOWS_UAP</DefineConstants>
+    <Optimize>true</Optimize>
+    <NoWarn>;2008</NoWarn>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <UseVSHostingProcess>false</UseVSHostingProcess>
+    <ErrorReport>prompt</ErrorReport>
+    <Prefer32Bit>true</Prefer32Bit>
+  </PropertyGroup>
+  <ItemGroup>
+    <!-- A reference to the entire .Net Framework and Windows SDK are automatically included -->
+    <None Include="project.json" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="AppService.cs" />
+    <Compile Include="BackgroundOperations\BackgroundOperations.cs" />
+    <Compile Include="CallRtcTask.cs" />
+    <Compile Include="Helpers\Current.cs" />
+    <Compile Include="Helpers\VccCallHelper.cs" />
+    <Compile Include="Helpers\EndpointHelper.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <SDKReference Include="WindowsMobile, Version=10.0.10240.0">
+      <Name>Windows Mobile Extensions for the UWP</Name>
+    </SDKReference>
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\VoipBackEnd\VoipBackEnd.vcxproj">
+      <Project>{fc9cbb95-624c-4ce8-86a8-3ab5a415aa65}</Project>
+      <Name>VoipBackEnd</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <PropertyGroup Condition=" '$(VisualStudioVersion)' == '' or '$(VisualStudioVersion)' &lt; '14.0' ">
+    <VisualStudioVersion>14.0</VisualStudioVersion>
+  </PropertyGroup>
+  <Import Project="$(MSBuildExtensionsPath)\Microsoft\WindowsXaml\v$(VisualStudioVersion)\Microsoft.Windows.UI.Xaml.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: /pjproject/branches/projects/uwp/pjsip/build/pjsua2_lib.vcxproj
===================================================================
--- /pjproject/branches/projects/uwp/pjsip/build/pjsua2_lib.vcxproj	(revision 5253)
+++ /pjproject/branches/projects/uwp/pjsip/build/pjsua2_lib.vcxproj	(revision 5254)
@@ -79,5 +79,5 @@
   <PropertyGroup Label="Globals">
     <ProjectGuid>{B82CDD25-6903-430E-BD38-D8129A2015C1}</ProjectGuid>
-    <RootNamespace>pjsua2_lib</RootNamespace>    
+    <RootNamespace>pjsua2_lib</RootNamespace>
     <!-- Specific UWP property -->
     <DefaultLanguage>en-US</DefaultLanguage>
@@ -86,5 +86,5 @@
     <WindowsTargetPlatformVersion Condition="'$(API_Family)'=='UWP'">$(PlatformVersion)</WindowsTargetPlatformVersion>
     <WindowsTargetPlatformMinVersion Condition="'$(API_Family)'=='UWP'">$(PlatformVersion)</WindowsTargetPlatformMinVersion>
-    <ApplicationTypeRevision Condition="'$(API_Family)'=='UWP'">$(AppTypeRev)</ApplicationTypeRevision>    
+    <ApplicationTypeRevision Condition="'$(API_Family)'=='UWP'">$(AppTypeRev)</ApplicationTypeRevision>
   </PropertyGroup>
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.Default.props" />
@@ -200,5 +200,6 @@
   <PropertyGroup>
     <PlatformToolset>$(BuildToolset)</PlatformToolset>
-    <CharacterSet Condition="'$(API_Family)'!='WinDesktop'"></CharacterSet>
+    <CharacterSet Condition="'$(API_Family)'!='WinDesktop'">
+    </CharacterSet>
   </PropertyGroup>
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.props" />
@@ -322,4 +323,5 @@
       <PrecompiledHeaderOutputFile>
       </PrecompiledHeaderOutputFile>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
     </ClCompile>
     <Lib>
